
#include <cstdlib>
#include <cstdio>
#include <iostream>
#include <string>
#include <sstream>
#include <fstream>

#include "interface.h"
#include "param_tuning/param_tune_window.cxx"

static void quit() {
    exit(0);
}
static void refresh_query() {
    std::ostringstream qstrs;
    qstrs << "\n";  // just so it displays nicer in the query box
    if (v_drums ->value() == 1) {qstrs << "voice(drums), "
                                       << "shortest_duration(drums," << sn_drums->mvalue()->label() << "), ";
                                }
    if (v_bass  ->value() == 1) {qstrs << "voice(bass), set_range(bass,c,3,-"
                                       << r_bass_low->value() << "," << r_bass_up->value() << "), "
                                       << "instrument(bass,'" << i_bass->mvalue()->label() << "'), "
                                       << "max_jump(bass," << mj_bass->value() << "), "
                                       << "shortest_duration(bass," << sn_bass->mvalue()->label() << "), ";
                                 if (mra_bass->value()==1) qstrs << "max_repeat(bass," << mr_bass->value() << "), ";
                                }
    if (v_chords->value() == 1) {qstrs << "voice(chords), "
                                       << "instrument(chords,'" << i_chords->mvalue()->label() << "'), "
                                       << "chord_style(" << (chords_offbeat->value() == 1 ? "offbeat" : "onbeat") << "), "
                                       << "shortest_duration(chords," << sn_chords->mvalue()->label() << "), ";
                                }
    if (v_melody->value() == 1) {qstrs << "voice(melody), set_range(melody,c,4,-"
                                       << r_melody_low->value() << "," << r_melody_up->value() << "), "
                                       << "instrument(melody,'" << i_melody->mvalue()->label() << "'), "
                                       << "max_jump(melody," << mj_melody->value() << "), "
                                       << "shortest_duration(melody," << sn_melody->mvalue()->label() << "), ";
                                 if (mra_melody->value()==1) qstrs << "max_repeat(melody," << mr_melody->value() << "), ";
                                }

    qstrs << "meter(" << meter1->mvalue()->label() << "," << meter2->mvalue()->label() << "), ";
    if (play->value() == 1) qstrs << "play, ";
    if (show->value() == 1) qstrs << "show, ";
    if (major->value() == 1) qstrs << "key(major), ";
    if (minor->value() == 1) qstrs << "key(minor), ";
    qstrs << "repeats(" << repeats->value() <<"), ";
    qstrs << "tempo(" << tempo->value() << "), "
          << "measures(" << measures->value() << ")";
    std::string qstr = qstrs.str();

    Fl_Text_Buffer* newtext =  new Fl_Text_Buffer(100);
    newtext->text(qstr.c_str());
    query->buffer(newtext);
}
static void compose() {
    progress->label("  Composing: making query");
    progress->value(1);
    progress->show();
    Fl::flush();
    refresh_query();
//    save_parameters();
    Fl_Text_Buffer*  q = query->buffer();
    q->savefile("goal",q->length());

    progress->label("  Composing: recompiling program");
    progress->value(2);
    Fl::flush();
    system("./handler1");

    progress->label("  Composing: running program");
    progress->value(4);
    Fl::flush();
    system("./handler2");

    progress->label("  Composing: calling Lilypond");
    progress->value(7);
    Fl::flush();
    system("./handler3");

    if (play->value()==1) {
        progress->label("  Composing: calling TiMidity++");
        progress->value(8);
        Fl::flush();
        system("./handler4");
    }
    if (show->value()==1) {
        progress->label("  Composing: calling GV");
        progress->value(9);
        Fl::flush();
        system("./handler5");
    }
    progress->label("  Composing: done");
    progress->value(10);
    Fl::flush();
    Fl::wait(3);
    progress->hide();

}

#include "interface.cxx"
